﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;

	public class Fibonacci extends Sprite
	{
		private var max:Number;
		private var fibonacci:Number;
		private var accident:Number;
		private var rapport:Number;
		private var rad:Number;
		private var growth:Number;
		private var sc_x:Number;
		private var sc_y:Number;
		private var rpx:Number;
		private var rpy:Number;
		
		private var cur:Number;
		private var rot:Number;
		public function Fibonacci()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			setup();
		}
		private function setup():void
		{
			max			= 500;
			fibonacci	= 1/1.618033989;
			accident	= .998;
			rapport 	= 360-360*fibonacci - 5;
			rad 		= 20;
			growth		= 1.050;
			sc_x		= 12;
			sc_y		= 7;
			rpx			= 1.001;
			rpy			= 1.018;
			cur			= max;
			rot			= 0;
		}
		
		private function addedHandler(e:Event):void
		{
			addEventListener(Event.ENTER_FRAME, enterhandler);
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.CLICK, clickHandler);
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			graphics.clear();
			setup();
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			graphics.clear();
			setup();
			addEventListener(Event.ENTER_FRAME, enterhandler);
		}
		
		private function enterhandler(e:Event):void
		{
			if(cur)
			{
				cur--;
				//rapport*=accident;
				sc_x*=rpx;
				sc_y*=rpy;
				rot += rapport;
				rot-= new int(rot/360)*360;
				rad*=growth;
				var x:Number = stage.stageWidth/2+Math.cos(rot * Math.PI/180) *rad;
				var y:Number = stage.stageHeight/2+Math.sin(rot * Math.PI/180) *rad;		
				var x2:Number = stage.stageWidth/2+Math.cos(rot * Math.PI/180) *rad;
				var y2:Number = stage.stageHeight/2+Math.sin(rot * Math.PI/180) *rad;
				if(cur!= (max-1)){
					graphics.lineStyle(10,Math.round(0x000000),.2);
					graphics.lineTo(stage.stageWidth/2,stage.stageHeight/2);
					graphics.lineTo(x,y);
					
					graphics.lineStyle(2,Math.round(0xFF0A0A),.9);
					graphics.lineTo((stage.stageWidth/2)*mouseX/300,(stage.stageHeight/2)*mouseY/300);
					graphics.lineTo(x2,y2);
					}else{
					graphics.moveTo(x,y);
				}
			}else{
				removeEventListener(Event.ENTER_FRAME,enterhandler);
			}
		}
		
	}
}